//-----------------------------------------------------------------------------
/*
Programmed by Olivier Sangala
http://olivier.sangala.free.fr
olivier_sangala@hotmail.com
*/
//-----------------------------------------------------------------------------

// C Header File
// Created 09/02/02; 19:30:58


//--------------------------------------------------------------------------

#define LEVEL_WIDTH (64)
#define LEVEL_HEIGHT (64)

#define BOARD_WIDTH (20)
#define BOARD_HEIGHT (20)

#define LEVELS_MAX (1024)
#define HISTORY_SIZE (1024)
#define STATS_LEFT (105)

//--------------------------------------------------------------------------

enum {T_UP,T_LEFT,T_DOWN,T_RIGHT};

//--------------------------------------------------------------------------

typedef struct
{
int x,y;
}
TPoint;

typedef struct
{

int moves;
int moves_max;
int balls;
int pushes;
int saved;

TPoint SOKO_Pos;
TPoint Scroll_Pos;

int MD_Way;
int MD_MoveBall;

char * VarPtr;
int file_num;
int level_num;
int levels_max;

char LevelMat[LEVEL_WIDTH][LEVEL_HEIGHT];
char History[HISTORY_SIZE];
char*LevelsPtr[LEVELS_MAX];

}
TGame;

//--------------------------------------------------------------------------

void InputStr (char *buffer, short maxlen);
void RefreshTile(int x, int y);
void RefreshScreen(void);
void RefreshStats(void);
void GetLevelsOffsets(void);
int LoadFile (void);
void LoadLevel (void);
void WayToPoint (int way, TPoint * Point);
void MoveSokoban(int way);
void AddToHistory(int way, int movebox);
void UndoMove(void);
void RedoMove(void);
void CONV_HP_MD(char * HistoryPtr);
void CONV_MD_HP(char * HistoryPtr);
void Menu_Select_Level(void);



//--------------------------------------------------------------------------

